//main formula: ( (t&t>>13) * ((t>>5|t>>9)&255) )&255           @ 31818 Hz

module amus(
 input in_clk,          // clock 14MHz
 output reg out_snd,    // sound
 output out_clk         // dummy clock
);

 reg [20:0] t;
 reg [8:0] pwmcnt;
 wire sample;
 assign sample = (next_pwmcnt==9'd440);
 wire [8:0] next_pwmcnt;
 assign next_pwmcnt = pwmcnt + 9'd1;
 always @(posedge in_clk)
  if (sample)
  begin
   pwmcnt <= 9'd0;
   t <= t + 21'd1;
  end
  else
   pwmcnt <= next_pwmcnt;

 assign out_clk = pwmcnt[2];

 reg [7:0] aaa, bbb, ccc, dac;
 always @(posedge in_clk)
  if (sample)
  begin
   dac <= ccc;
   aaa <= t[7:0] & t[20:13];
   bbb <= t[12:5] | t[16:9];
   ccc <= 8'd0;
  end
  else
  begin
   if (bbb)
   begin
    ccc <= ccc + aaa;
    bbb <= bbb - 8'd1;
   end
  end

 always @(posedge in_clk)  out_snd <= ({1'b0,dac}>=pwmcnt);

endmodule
